<html>
<head>
<title>Ogre::AlignedMemory Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1AlignedMemory.html">AlignedMemory</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::AlignedMemory Class Reference<div class="ingroups"><a class="el" href="group__Memory.html">Memory</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::AlignedMemory" -->
<p>Class to provide aligned memory allocate functionality.  
 <a href="classOgre_1_1AlignedMemory.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreAlignedAllocator_8h_source.html">OgreAlignedAllocator.h</a>&gt;</code></p>

<p><a href="classOgre_1_1AlignedMemory-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AlignedMemory.html#a215ddaa2cf45c92ec39560dd43bed7b6">allocate</a> (size_t size, size_t alignment)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate memory with given alignment.  <a href="#a215ddaa2cf45c92ec39560dd43bed7b6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AlignedMemory.html#a939feb25c02c78968b57502809ed836a">allocate</a> (size_t size)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate memory with default platform dependent alignment.  <a href="#a939feb25c02c78968b57502809ed836a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AlignedMemory.html#aec9665c128b282869284a6025520adee">deallocate</a> (void *p)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Deallocate memory that allocated by this class.  <a href="#aec9665c128b282869284a6025520adee"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Class to provide aligned memory allocate functionality. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>All SIMD processing are friendly with aligned memory, and some SIMD routines are designed for working with aligned memory only. If the data are intended to use SIMD processing, it's need to be aligned for better performance boost. In additional, most time cache boundary aligned data also lead to better performance even if didn't used SIMD processing. So this class provides a couple of functions for allocate aligned memory. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>Anyways, in general, you don't need to use this class directly, <a class="el" href="namespaceOgre.html">Ogre</a> internally will take care with most SIMD and cache friendly optimisation if possible. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>This isn't a "one-step" optimisation, there are a lot of underlying work to achieve performance boost. If you didn't know what are you doing or what there are going, just ignore this class. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>This class intended to use by advanced user only. </dd></dl>

<p>Definition at line <a class="el" href="OgreAlignedAllocator_8h_source.html#l00063">63</a> of file <a class="el" href="OgreAlignedAllocator_8h_source.html">OgreAlignedAllocator.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a215ddaa2cf45c92ec39560dd43bed7b6"></a><!-- doxytag: member="Ogre::AlignedMemory::allocate" ref="a215ddaa2cf45c92ec39560dd43bed7b6" args="(size_t size, size_t alignment)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void* <a class="el" href="classOgre_1_1AlignedMemory.html#a215ddaa2cf45c92ec39560dd43bed7b6">Ogre::AlignedMemory::allocate</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>alignment</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate memory with given alignment. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">size</td><td>The size of memory need to allocate. </td></tr>
    <tr><td class="paramname">alignment</td><td>The alignment of result pointer, must be power of two and in range [1, 128]. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>The allocated memory pointer. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>On failure, exception will be throw. </dd></dl>

<p>Referenced by <a class="el" href="OgreMemoryStdAlloc_8h_source.html#l00113">Ogre::StdAlignedAllocPolicy&lt; Alignment &gt;::allocateBytes()</a>.</p>

</div>
</div>
<a class="anchor" id="a939feb25c02c78968b57502809ed836a"></a><!-- doxytag: member="Ogre::AlignedMemory::allocate" ref="a939feb25c02c78968b57502809ed836a" args="(size_t size)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void* <a class="el" href="classOgre_1_1AlignedMemory.html#a215ddaa2cf45c92ec39560dd43bed7b6">Ogre::AlignedMemory::allocate</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate memory with default platform dependent alignment. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The default alignment depend on target machine, this function guarantee aligned memory according with SIMD processing and cache boundary friendly. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">size</td><td>The size of memory need to allocate. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>The allocated memory pointer. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>On failure, exception will be throw. </dd></dl>

</div>
</div>
<a class="anchor" id="aec9665c128b282869284a6025520adee"></a><!-- doxytag: member="Ogre::AlignedMemory::deallocate" ref="aec9665c128b282869284a6025520adee" args="(void *p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1AlignedMemory.html#aec9665c128b282869284a6025520adee">Ogre::AlignedMemory::deallocate</a> </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Deallocate memory that allocated by this class. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">p</td><td>Pointer to the memory allocated by this class or <b>NULL</b> pointer. </td></tr>
  </table>
  </dd>
</dl>
<dl class="user"><dt><b></b></dt><dd>On <b>NULL</b> pointer, nothing happen. </dd></dl>

<p>Referenced by <a class="el" href="OgreMemoryStdAlloc_8h_source.html#l00130">Ogre::StdAlignedAllocPolicy&lt; Alignment &gt;::deallocateBytes()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreAlignedAllocator_8h_source.html">OgreAlignedAllocator.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:54
</p>
</body>
</html>
